use tokio::net::TcpListener;
use tokio::io::{AsyncWriteExt, AsyncReadExt};

#[tokio::main]
async fn main() -> Result<(), Box<dyn std::error::Error>> {
    let listener = TcpListener::bind("localhost:5000").await?;
    println!("Server listening ...");

    loop {
        let (mut socket, addr) = listener.accept().await?;

        tokio::spawn(async move {
            println!("new client: {:?}", addr);
            let mut buffer = String::new();
            if let Err(e) = socket.read_to_string(&mut buffer).await {
                eprintln!("Error reading tcp input; err = {:?}", e);
                return;
            }

            if let Err(e) = socket.write_all(format!("Hello world! {}", buffer).as_bytes()).await {
                eprintln!("Error writing tcp response; err = {:?}", e);
                return;
            }
        });
    }
    Ok(())
}
